
//#include "sdl.h"
//#include "sdl_image.h"

#include "system.h"
#include "enums.h"

#include <iostream>
#include <fstream>

using namespace std;

void Setup();

int main(int argc, char* argv[]) {

	Setup();

	System& sys = System::getInstance();
	SystemReturn sr;

	//There's probably a better way to organize this loop section oh well =)
	sys.Draw();

	do {
		sr = sys.DoTurn();

		switch (sr) {
			case SYS_QUIT:
				return 0;
			case SYS_GOOD:
				sys.ChangeTurn();
				break;
			case SYS_CONTINUE:
				do {
					if (sys.isQuitTime())
						return 0;
					sys.Draw();
					sr = sys.DoTurnMove(NULL, DIR_NODIR, true);
				} while (sr == SYS_CONTINUE || sr == SYS_BAD);
				if (sr != SYS_WIN)
					sys.ChangeTurn();
				break;
			case SYS_BAD:	//reprompt
				break;
			case SYS_WIN:
				break;
		}
		sys.Draw();
	} while (sr != SYS_WIN);

	cout << endl << "Press escape to exit." << endl;
	while (sys.CheckEvents())
		sys.Draw();
	return 0;
}

void Setup() {
	int depthmin, depthmax;
	bool minplayerComp = true;
	bool maxplayerComp = true;

	cout << "How tough should the AI be? Higher numbers are more difficult." << endl
		 << "For a human player, use '-1' for the depth." << endl;

	cout << "Depth for player 1, top player (red)? ";
	cin >> depthmin;
	while (cin.fail() || depthmin < -1) {
		cin.clear();
		cin.ignore(100, '\n');
		cout << "Bad selection. Depth for top player? ";
		cin >> depthmin;
	}

	cout << "Depth for player 2, bottom player (black)? ";
	cin >> depthmax;
	while (cin.fail() || depthmax < -1) {
		cin.clear();
		cin.ignore(100, '\n');
		cout << "Bad selection. Depth for bottom player? ";
		cin >> depthmax;
	}
	cin.ignore(100, '\n');

	System& sys = System::getInstance();
	if (depthmin == -1)
		minplayerComp = false;

	if (depthmax == -1)
		maxplayerComp = false;

	sys.Init(depthmin, depthmax, minplayerComp, maxplayerComp);
}