
#ifndef MOVE_H
#define MOVE_H

extern enum Direction;
class Board;
class Checker;

/*enum MoveCode {
	MC_MOVE_OK			= 0x01,	//If this is not set, move was bad
	MC_BAD_SELECT		= 0x02,
	MC_BADMOVE_NME		= 0x04,
	MC_BADMOVE_WALL		= 0x08,
	MC_JUMPABLE			= 0x10,
	MC_CANMULTI			= 0x20,
	MC_JUMPDONE			= 0x40,
	MC_KING				= 0x80
};*/

enum MoveCode {
	MC_BADSELECT,		//There's no checker @ this spot
	//The player is trying to move...
	MC_BADMOVE_NME,		//...into an enemy checker
	MC_BADMOVE_WALL,	//...into the wall or his own checker
	MC_MOVEOK,			//...to a clear spot from a clear spot
	MC_JUMPDONE,		//...to a clear spot from on top of another checker [automatic]
	MC_JUMPABLE,		//...to a checker that has a clear spot after it
	MC_MULTIJUMP,		//...to a space he can multijump from
	MC_KING,			//...to the end of the board [via MOVEOK]
	MC_JUMPDONEKING		//...to the end of the board [via JUMPDONE]
};

class Move {

	int fromX;
	int fromY;
	Direction dir;
	int toX;
	int toY;
	Checker* checker;
	Board* on;

	//Functions for movement calculations
	int NewX(int x);
	int NewY(int y);
	bool CheckKing(int toY);

public:
	int Rate();
	MoveCode CalcType(const Player* onCheckerLast = NULL, bool multicheck = false);
	MoveCode Do();
	void Init(int pfromX, int pfromY, Direction pdir, Checker* pmoveChecker, Board* pon);
	bool isBad(MoveCode code) { return (code == MC_BADSELECT || code == MC_BADMOVE_WALL || code == MC_BADMOVE_NME); }
	bool isJump(MoveCode code) { return (code == MC_JUMPABLE || code == MC_MULTIJUMP || code == MC_JUMPDONE || code == MC_JUMPDONEKING); }
	bool wasJump(MoveCode code) { return (code == MC_JUMPDONE || code == MC_JUMPDONEKING); }
	long Rate(MoveCode code, int mult, /*Checker* moved, Direction dir,*/ bool blockedOnly = false);

	int getToX() const { return toX; }
	int getToY() const { return toY; }
};

#endif