
#ifndef RENDERER_H
#define RENDERER_H

#include <sdl.h>
#include <sdl_image.h>
//#include <vector>
#include <map>
//#include <string>
using namespace std;

class Renderer {

	enum Keys { BLACK = 1, BLACKSIDE, RED, REDSIDE, BOARD, BOX, BADBOX, SELECTION, SIDEBAR, END };
	enum UI { REDTURN = '!', BLACKTURN = '@', THINKING = '#', REDWINS = '$', BLACKWINS = '%', EXIT = '+' };

	static const int SCREEN_W = 640;
	static const int SCREEN_H = 480;
	static const int CHECKER_OFFSET = 15;
	static const int SPACE_W = 60;
	static const int SPACE_H = 60;
	static const int SPACE_GEN = 60;	//used in the conversionsatm since w & h are the same. gen as in general

	SDL_Surface* display;

	//NOTES:
	//'a'-'l' (L) and 'A'-'L' are reserved for checkers
	//chars 1 - 11 are used in Keys

	map<char, SDL_Surface*> textures;	//Surface* b/c IMG_Load returns pointer. char b/c keys can be cast to ptrc

	map<char, SDL_Rect> checkers;
	map<Keys, SDL_Rect> other;

	map<UI, SDL_Rect> ui;
	map<UI, SDL_Rect> buttons;

	inline Sint16 ToScreenCoord(int num);
	inline Sint16 FromScreenCoord(int num);
	inline Sint16 Snap(Sint16 num);
	bool Inside(int testx, int testy, int boundxlo, int w, int boundylo, int h);
	bool onBoard;
	
public:
	bool Init();
	void UpdateMouse(Sint16 px, Sint16 py);
	void UpdateSelect(int px, int py);
	void UpdateChecker(char key);
	void UpdateCheckers();
	bool isExit(int x, int y);
	void Draw();
	~Renderer();
};

#endif